import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["url"];
import { expect } from 'chai';
import { diffJson } from 'diff';
import { FakeGenerator } from './FakeGenerator';
var _instance;
var FetchFetcherFakerManager = /*#__PURE__*/function () {
  FetchFetcherFakerManager.create = function create(FetchFetcher) {
    if (_instance) return _instance;
    _instance = new FetchFetcherFakerManager(FetchFetcher);
    return _instance;
  };
  function FetchFetcherFakerManager(FetchFetcher) {
    var _this = this;
    this._fakeRequests = void 0;
    this._methods = ['get', 'patch', 'post'];
    this.FetchFetcher = FetchFetcher;
    this._originalsFetcher = this._methods.map(function (method) {
      return _this.FetchFetcher.prototype[method];
    });
    this._fakeRequests = {};
    this._methods.forEach(function (method) {
      _this.FetchFetcher.prototype[method] = _this._request(method);
    });
  }
  var _proto = FetchFetcherFakerManager.prototype;
  _proto.addMock = function addMock(_ref) {
    var url = _ref.url,
      method = _ref.method,
      error = _ref.error,
      mock = _ref.mock,
      force = _ref.force;
    var key = method.toUpperCase() + '::' + url;
    if (!force && this._fakeRequests[key]) throw new Error("[FetchFetcherFakerManager#addMock] forbidden overwrite the request " + key);
    this._fakeRequests[key] = Promise.resolve([error, mock]);
  };
  _proto.validate = function validate(_ref2) {
    var url = _ref2.url,
      method = _ref2.method;
    var key = method.toUpperCase() + '::' + url;
    if (this._fakeRequests[key]) throw new Error("[FetchFetcherFakerManager#validate] request " + key + " don't consume");
  };
  _proto.restore = function restore() {
    var _this2 = this;
    if (Object.keys(this._fakeRequests).length === 0) {
      this._methods.forEach(function (method, index) {
        return _this2.FetchFetcher.prototype[method] = _this2._originalsFetcher[index];
      });
    } else {
      console.warn("[FetchFetcherFakerManager#restore]\n        Unabled restore the FetchFetcher because there are request w/out been consume\n        - Dont match any mock:\n        " + Object.keys(this._fakeRequests).join('\n\t\t') + "\n      ");
    }
  };
  _proto._request = function _request(method) {
    var self = this;
    return function (options) {
      var requestKey = method.toUpperCase() + '::' + options.url;
      // this === FetchFetcher instance
      if (self._fakeRequests[requestKey]) {
        var response = self._fakeRequests[requestKey];
        delete self._fakeRequests[requestKey];
        return response;
      } else {
        console.warn("[FetchFetcherFakerManager#_request]\n        - Request make " + requestKey + "\n        - Dont match any mock:\n        " + Object.keys(self._fakeRequests).join('\n\t\t') + "\n      ");
      }
      var url = options.url,
        innerOptions = _objectWithoutPropertiesLoose(options, _excluded);
      return this._request(url, _extends({}, innerOptions, {
        method: method
      }));
    };
  };
  return FetchFetcherFakerManager;
}();
export var MotherObject = function MotherObject() {};
export var ModelMotherObject = /*#__PURE__*/function (_MotherObject) {
  _inheritsLoose(ModelMotherObject, _MotherObject);
  function ModelMotherObject() {
    var _this3;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this3 = _MotherObject.call.apply(_MotherObject, [this].concat(args)) || this;
    _this3._model = void 0;
    return _this3;
  }
  var _proto2 = ModelMotherObject.prototype;
  _proto2.withoutError = function withoutError(_temp) {
    var _ref3 = _temp === void 0 ? {} : _temp,
      error = _ref3.error;
    expect(error).to.be.eql(null);
    return this;
  };
  _proto2.withError = function withError(_temp2) {
    var _ref4 = _temp2 === void 0 ? {} : _temp2,
      error = _ref4.error,
      klass = _ref4.klass;
    expect(error).instanceof(klass);
    return this;
  };
  _proto2.isNull = function isNull(_temp3) {
    var _ref5 = _temp3 === void 0 ? {} : _temp3,
      json = _ref5.json;
    expect(json).to.be.eql(null);
  };
  _proto2.equals = function equals(_temp4) {
    var _ref6 = _temp4 === void 0 ? {} : _temp4,
      json = _ref6.json;
    try {
      expect(this.jsonModel()).to.be.eql(json);
    } catch (err) {
      // pretty print this._model.toJSON() / json
      var diff = diffJson(this.jsonModel(), json);
      diff.forEach(function (part) {
        console.log("%c " + part.value, "color: " + (part.added ? 'green' : part.removed ? 'red' : 'grey'));
      });
      throw err;
    }
    return this;
  };
  _proto2.jsonModel = function jsonModel() {
    if (!this._model) throw new Error("[ModelMotherObject#jsonModel] model is undefined model(" + this._model + ")");
    return this._model.toJSON();
  };
  return ModelMotherObject;
}(MotherObject);
export var DataSourceMotherObjectFactory = function DataSourceMotherObjectFactory(DataSource) {
  return /*#__PURE__*/function (_MotherObject2) {
    _inheritsLoose(DataSourceMotherObject, _MotherObject2);
    function DataSourceMotherObject() {
      var _this4;
      _this4 = _MotherObject2.call(this) || this;
      _this4._fillDataSource = void 0;
      _this4._originalData = void 0;
      _this4._faker = void 0;
      _this4._mock = void 0;
      _this4._faker = FakeGenerator.create();
      _this4._originalData = DataSource.prototype.data;
      DataSource.prototype.data = _this4._response.bind(_assertThisInitialized(_this4));
      return _this4;
    }
    var _proto3 = DataSourceMotherObject.prototype;
    _proto3.success = function success() {
      if (this._fillDataSource) throw new Error('[DataSourceMotherObject#success] Call success w/out been consume a previous call');
      this._mock = this.generate(this._faker);
      this._fillDataSource = true;
    };
    _proto3.restore = function restore() {
      if (this._fillDataSource && this._mock !== undefined) throw new Error("[DataSourceMotherObject#restore] consume DataSource before restore it");
      DataSource.prototype.data = this._originalData;
    };
    _proto3._response = function _response() {
      var res = _extends({}, this._mock);
      this._mock = undefined;
      return res;
    };
    return DataSourceMotherObject;
  }(MotherObject);
};
export var RequestMotherObjectFactory = function RequestMotherObjectFactory(FetchFetcher) {
  return /*#__PURE__*/function (_MotherObject3) {
    _inheritsLoose(RequestMotherObject, _MotherObject3);
    function RequestMotherObject() {
      var _this5;
      _this5 = _MotherObject3.call(this) || this;
      _this5._url = void 0;
      _this5._method = void 0;
      _this5._error = void 0;
      _this5._mock = void 0;
      _this5._fetchFetcherFakerManager = FetchFetcherFakerManager.create(FetchFetcher);
      _this5._faker = FakeGenerator.create();
      return _this5;
    }
    var _proto4 = RequestMotherObject.prototype;
    _proto4.request = function request(_ref7) {
      var url = _ref7.url,
        _ref7$method = _ref7.method,
        method = _ref7$method === void 0 ? 'get' : _ref7$method;
      this._url = url;
      this._method = method;
      return this;
    };
    _proto4.success = function success() {
      if (this._error !== undefined) throw new Error('[MotherObject#success] Dont call to .success after call to .error method');
      this._mock = this.generate(this._faker);
      this._fetchFetcherFakerManager.addMock({
        url: this._url,
        method: this._method,
        mock: this._mock
      });
      return this;
    };
    _proto4.error = function error(_ref8) {
      var _error = _ref8.error;
      if (!_error) throw new Error('[MotherObject#error] if want to return an error from the API you must to instanciate a error');
      if (this._mock !== undefined) throw new Error('[MotherObject#error] Dont call to .error after call to .success method');
      this._error = _error;
      this._fetchFetcherFakerManager.addMock({
        url: this._url,
        method: this._method,
        error: this._error
      });
      return this;
    };
    _proto4.toJSON = function toJSON() {
      return this._error ? this._error : this._mock;
    };
    _proto4.updateMock = function updateMock() {
      this._fetchFetcherFakerManager.addMock({
        url: this._url,
        method: this._method,
        mock: this._mock,
        force: true
      });
      return this;
    };
    _proto4.validate = function validate() {
      if (!this._url && !this._method) return;
      this._fetchFetcherFakerManager.validate({
        url: this._url,
        method: this._method
      });
    };
    _proto4.restore = function restore() {
      this._fetchFetcherFakerManager.restore();
    };
    return RequestMotherObject;
  }(MotherObject);
};